from typing import Type, Callable, Optional

from cpl_core.configuration import ConfigurationABC
from cpl_core.type import T


class SettingsHelper:
    @staticmethod
    def configure_settings_with_sub_settings(
        config: ConfigurationABC, settings: Type[T], list_atr: Callable, atr: Callable
    ):
        settings: Optional[settings] = config.get_configuration(settings)
        if settings is None:
            return

        for sub_settings in list_atr(settings):
            config.add_configuration(f"{type(sub_settings).__name__}_{atr(sub_settings)}", sub_settings)
